<template>
    <div class="d-flex content-center">
        <CContainer fluid>
            <CRow class="justify-content-center">
                <CCol md="6">
                    <CCard class="mx-4 mb-0">
                        <CCardBody class="p-4" >
                            <CForm @submit.prevent="registerUser">
                                <h1>Inscription</h1>
                                <p class="text-muted">Créer un compte</p>

                                <div class="custom-control custom-switch" style="text-align: left">
                                    <input type="checkbox" class="custom-control-input" id="inviteSwitch" v-on:click="toggleInvite()">
                                    <label class="custom-control-label" for="inviteSwitch" >Utilisateur Invité</label>
                                </div>
                                <br />

                                <CInput
                                        placeholder="Nom"
                                        autocomplete="surname"
                                        id="surname"
                                        v-model="register.surname"
                                        v-show="!inviteState"
                                >
                                    <template #prepend-content><CIcon name="cil-user"/></template>
                                </CInput>
                                <CInput
                                        placeholder="Prénom"
                                        autocomplete="name"
                                        id="name"
                                        v-model="register.name"
                                        v-show="!inviteState"
                                >
                                    <template #prepend-content><CIcon name="cil-user"/></template>
                                </CInput>
                                <CInput
                                        placeholder="E-mail"
                                        autocomplete="email"
                                        prepend="@"
                                        id="email"
                                        type="email"
                                        v-model="register.email"
                                        required
                                />
                                <CInput
                                        placeholder="Mot de passe"
                                        type="password"
                                        autocomplete="new-password"
                                        v-model="register.password"
                                >
                                    <template #prepend-content><CIcon name="cil-lock-locked"/></template>
                                </CInput>
                                <CInput
                                        placeholder="Confirmer le mot de passe"
                                        type="password"
                                        autocomplete="new-password"
                                        class="mb-4"
                                        v-model="register.confirm_password"
                                >
                                    <template #prepend-content><CIcon name="cil-lock-locked"/></template>
                                </CInput>
                                <CInput
                                        placeholder="Entreprise"
                                        type="text"
                                        id="entreprise"
                                        autocomplete="entreprise"
                                        class="mb-4"
                                        v-model="register.company"
                                        v-show="!inviteState"
                                >
                                    <template #prepend-content><CIcon name="cil-globe-alt"/></template>
                                </CInput>
                                <CInput
                                        placeholder="Poste"
                                        type="text"
                                        id="poste"
                                        autocomplete="position"
                                        class="mb-4"
                                        v-model="register.job"
                                        v-show="!inviteState"
                                >
                                    <template #prepend-content><CIcon name="cil-file"/></template>
                                </CInput>

                                <div class="custom-control custom-switch" style="text-align: left" v-show="!inviteState">
                                    <input type="checkbox" class="custom-control-input" id="customSwitches" v-on:click="toggleAdmin()">
                                    <label class="custom-control-label" for="customSwitches" >Admin</label>
                                </div>
                                <br />

                                <CButton color="success" type="submit" block>Créer compte</CButton>
                            </CForm>
                        </CCardBody>
                    </CCard>
                </CCol>
            </CRow>
        </CContainer>
    </div>
</template>
<script>
    import swal from "sweetalert";

    export default {
        components: {},
        data() {
            return {
                register: {
                    surname: null,
                    name: null,
                    email: "",
                    password: "",
                    confirm_password: "",
                    admin: false,
                    company : null,
                    job: null,
                    invite: false
                },
                adminState: false,
                inviteState: false
            };
        },
        methods: {
            async registerUser() {
                await this.$http.post("/api/users/register", this.register)
                    .then(response => {
                        if (response.status=== 201) {
                            this.$router.push("/dashboard");
                            swal("Succès", response.data.msg, "success");
                        }
                    })
                    .catch(error => {
                        if (error.response && error.response.status === 500) {
                            swal("Erreur", error.response.data, "error");
                        }
                        else {
                            swal("Erreur", "Une erreur est survenue", "error");
                        }
                    })
            },
            toggleAdmin(){
                this.adminState = !this.adminState
                this.register.admin =this.adminState;
            },
            toggleInvite(){
                this.inviteState = !this.inviteState
                this.register.invite =this.inviteState;
            }
        }
    };
</script>
